/* $Id: common_3dnow.c,v 1.2 1999/04/16 01:14:32 brianp Exp $ */

/*
 * Mesa 3-D graphics library
 * Version:  3.1
 * 
 * Copyright (C) 1999  Brian Paul   All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * BRIAN PAUL BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


/*
 * 3DNow! optimizations contributed by
 * Holger Waechtler <holger@akaflieg.extern.tu-berlin.de>
 */


#include "common_3dnow.h"


/*
         returns 1, if 3Dnow! extension is present.
*/
int hardware_supports_3dnow ()
{
int r;
__asm__ (
"    push    %%ebx                                                        \n"
"    pushfl                            # test for the cpuid command       \n"
"    pop     %%eax                     # (if the ID-Bit (Bit 21) in       \n"
"    mov     %%eax, %%ebx              #  EEFLAGS is writable, the        \n"
"    xor     $0x00200000, %%eax        #  cpuid command is present)       \n"
"    pushl   %%eax                                                        \n"
"    popfl                                                                \n"
"    pushfl                                                               \n"
"    pop     %%eax                                                        \n"
"    cmp     %%ebx, %%eax                                                 \n"
"    jz      2f                        # cpuid command not supported      \n"
"                                                                         \n"
"    xor     %%eax, %%eax              # %%eax = 0                        \n"
"    cpuid                                                                \n"
"    cmp     $0x68747541, %%ebx        # compare vendor string == 'Auth'? \n"
"    jne     2f                                                           \n"
"    cmp     $0x69746e65, %%edx        # 'enti'                           \n"
"    jne     2f                                                           \n"
"    cmp     $0x444d4163, %%ecx        # 'cAMD'   (= 'AuthenticAMD')      \n"
"    jne     2f                                                           \n"
"                                                                         \n"
"    movl    $0x80000000, %%eax        # extended functions supported ?   \n"
"    cpuid                                                                \n"
"    test    %%eax, %%eax                                                 \n"
"    jz      2f                                                           \n"
"                                                                         \n"
"    movl    $0x80000001, %%eax                                           \n"
"    cpuid                             # test for 3Dnow!                  \n"
"    test    $0x80000000, %%edx                                           \n"
"    mov     $1, %%ax                  # (detected 3Dnow! extension)      \n"
"    jmp     3f                                                           \n"
"                                                                         \n"
"2:  mov     $0, %%ax                  # (could not detect 3Dnow!         \n"
"                                      # capabilities or cpuid command    \n"
"3:  stc                               # not supported or unknown vendor) \n"
"    pop     %%ebx                                                        \n"
:"=a" (r)::"memory");
return r;
}

