#ifndef _FXVSETUP_H_
#define _FXVSETUP_H_

/* Mergable items first
 */
#define SETUP_RGBA 0x1
#define SETUP_TMU0 0x2
#define SETUP_TMU1 0x4
#define SETUP_XY   0x8
#define SETUP_Z    0x10
#define SETUP_W    0x20

#define MAX_MERGABLE 0x8


#define VARS_W  GLfloat wscale = fxMesa->wScale;

#define VARS_Z

#define VARS_TMU0							\
  GLuint tmu0_source = fxMesa->tmu_source[0];				\
  GLfloat (*tmu0_data)[4] = VB->TexCoordPtr[tmu0_source]->data;		\
  GLuint tmu0_sz = VB->TexCoordPtr[tmu0_source]->size;			\
  struct gl_texture_unit *t0 = &ctx->Texture.Unit[tmu0_source];		\
  GLfloat sscale0 = ((tfxTexInfo *) (t0->Current->DriverData))->sScale;	\
  GLfloat tscale0 = ((tfxTexInfo *) (t0->Current->DriverData))->tScale;

#define VARS_TMU1							\
  GLuint tmu1_source = fxMesa->tmu_source[1];				\
  GLfloat (*tmu1_data)[4] = VB->TexCoordPtr[tmu1_source]->data;		\
  GLuint tmu1_sz = VB->TexCoordPtr[tmu1_source]->size;			\
  struct gl_texture_unit *t1 = &ctx->Texture.Unit[tmu1_source];		\
  GLfloat sscale1 = ((tfxTexInfo *) (t1->Current->DriverData))->sScale;	\
  GLfloat tscale1 = ((tfxTexInfo *) (t1->Current->DriverData))->tScale;

#define VARS_RGBA GLubyte (*color)[4] = VB->ColorPtr->data; 

#define VARS_XY GLfloat (*win)[4] = VB->Win.data; 

#ifdef FX_V2
#  define DO_SETUP_XY {				\
  (v)->x=win[i][0];				\
  (v)->y=win[i][1];				\
}
#else
#  if (defined(__linux__) && defined(__i386__)) || defined(macintosh)
#    define DO_SETUP_XY {			\
       GLfloat t1 = win[i][0] + snapper;	\
       GLfloat t2 = win[i][1] + snapper;	\
       (v)->x = t1 - snapper;			\
       (v)->y = t2 - snapper;			\
     }
#  else
#    define DO_SETUP_XY {				\
        /* trunc (x,y) to multiple of 1/16 */		\
        (v)->x=((int)(win[i][0]*16.0f))*(1.0f/16.0f);	\
        (v)->y=((int)(win[i][1]*16.0f))*(1.0f/16.0f);	\
     }
#  endif
#endif



#define DO_SETUP_W { (v)->oow=wscale*win[i][3]; }

#define DO_SETUP_Z { (v)->ooz=win[i][2]; }

#define DO_SETUP_TMU0				\
{						\
  GrTmuVertex *tmu0 = &v->tmuvtx[0];		\
  tmu0->sow=sscale0*tmu0_data[i][0]*(v)->oow;	\
  tmu0->tow=tscale0*tmu0_data[i][1]*(v)->oow;	\
  tmu0->oow=(v)->oow;				\
} 

#define DO_SETUP_TMU1				\
{						\
  GrTmuVertex *tmu1 = &v->tmuvtx[1];		\
  tmu1->sow=sscale1*tmu1_data[i][0]*(v)->oow;	\
  tmu1->tow=tscale1*tmu1_data[i][1]*(v)->oow;	\
  tmu1->oow=(v)->oow;				\
}

#define DO_SETUP_RGBA					\
{							\
  GLubyte *col = color[i];				\
  (v)->r=UBYTE_COLOR_TO_FLOAT_255_COLOR(col[0]);	\
  (v)->g=UBYTE_COLOR_TO_FLOAT_255_COLOR(col[1]);	\
  (v)->b=UBYTE_COLOR_TO_FLOAT_255_COLOR(col[2]);	\
  (v)->a=UBYTE_COLOR_TO_FLOAT_255_COLOR(col[3]);	\
}

#define FIXUP_TMU0						\
   if (tmu0_sz == 4) {						\
      fxMesa->stw_hint_state |= GR_STWHINT_W_DIFF_TMU0;		\
      grHints(GR_HINT_STWHINT, fxMesa->stw_hint_state); 	\
      project_texcoords( &gWin[start].tmuvtx[0], tmu0_data,	\
			 VB->CullFlag[1], VB->ClipMask,		\
			 start, end );				\
   }

#define FIXUP_TMU1						\
   if (tmu1_sz == 4) {						\
      fxMesa->stw_hint_state |= GR_STWHINT_W_DIFF_TMU1;		\
      grHints(GR_HINT_STWHINT, fxMesa->stw_hint_state); 	\
      project_texcoords( &gWin[start].tmuvtx[1], tmu1_data,	\
			 VB->CullFlag[1], VB->ClipMask,		\
			 start, end );				\
   }


/* v - pointer to destination GrVertex
 * VB - source of data
 * i - index into vb for data
 */


#endif
