#ifndef _TRANSLATE_H_
#define _TRANSLATE_H_

#include "types.h"

/* Translate GL_UNSIGNED_BYTE, etc to the indexes used in the arrays
 * below.
 */
#define TYPE_IDX(t) ((t) & 0xf)

#define MAX_TYPES TYPE_IDX(GL_DOUBLE)+1      /* 0xa + 1 */

/* Only useful combinations are defined, thus there is no function to
 * translate eg, ubyte->float or ubyte->ubyte, which are never used.  
 */
extern trans_1ui_func gl_trans_1ui_tab[MAX_TYPES];
extern trans_1ub_func gl_trans_1ub_tab[MAX_TYPES];
extern trans_3f_func  gl_trans_3f_tab[MAX_TYPES];
extern trans_4ub_func gl_trans_4ub_tab[5][MAX_TYPES];
extern trans_4f_func  gl_trans_4f_tab[5][MAX_TYPES];

extern trans_elt_1ui_func gl_trans_elt_1ui_tab[MAX_TYPES];
extern trans_elt_1ub_func gl_trans_elt_1ub_tab[MAX_TYPES];
extern trans_elt_3f_func  gl_trans_elt_3f_tab[MAX_TYPES];
extern trans_elt_4ub_func gl_trans_elt_4ub_tab[5][MAX_TYPES];
extern trans_elt_4f_func  gl_trans_elt_4f_tab[5][MAX_TYPES];


extern void gl_init_translate( void );


#endif
